package ru.dbotthepony.mc.prng.mixin;

import net.minecraft.core.BlockPos;
import net.minecraft.util.RandomSource;
import net.minecraft.world.level.Level;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Redirect;
import ru.dbotthepony.mc.prng.BetterRandom;

@Mixin(Level.class)
public abstract class LevelMixin {
	@Shadow
	@Final
	private Thread thread;

	@Final // ensure it is on top-level
	@Redirect(
		method = "<init>",
		at = @At(
			value = "INVOKE",
			target = "Lnet/minecraft/util/RandomSource;create()Lnet/minecraft/util/RandomSource;"
		)
	)
	public RandomSource ensureBetterRandom() {
		return BetterRandom.createWorldRandom(() -> thread);
	}

	@Overwrite
	public BlockPos getBlockRandomPos(int x, int y, int z, int yMask) {
		long value = ((Level) (Object) this).random.nextLong();
		int selectX = (int) (value & 15);
		int selectZ = (int) ((value >>> 8) & 15);
		int selectY = (int) ((value >>> 16) & yMask);
		return new BlockPos(selectX + x, selectY + y, selectZ + z);
	}
}
